// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancyssllog.h 818 2010-09-08 20:43:13Z fancylibs $
**
** Copyright (C) 2003 EV-i Informationstechnologie GmbH
**
** Author: Wolfgang Glas / EV-i
**
** Global logging stuff.
**
*****************************************************************************/

#ifndef FANCYSSL_LOG_H
#define FANCYSSL_LOG_H

#include <fancylog.h>
#include <fancysslbase.h>

// facility masks:
// facility "fancysslbase"
#define  FANCYSSL_LOG_BASE     (1<<0)
// facility "fancysslpkey"
#define  FANCYSSL_LOG_PKEY     (1<<1)
// facility "fancysslx509"
#define  FANCYSSL_LOG_X509     (1<<2)
// facility "fancysslpkcs7"
#define  FANCYSSL_LOG_PKCS7    (1<<3)
// facility "fancysslsock"
#define  FANCYSSL_LOG_SOCK     (1<<4)
// facility "fancyssldigest"
#define  FANCYSSL_LOG_DIGEST   (1<<5)

namespace Fancy {
  namespace SSL {

    extern FANCYSSL_API fancylog_service *log_service;

    // parse for logging cmdline args and filter out recognized options.
    void FANCYSSL_API fancylog_parse_arg (int *argc, char **argv);

    inline void vfancylog (int facility,
                           int priority, const char *fmt, va_list ap)
      {
        va_list aq;
        va_copy(aq,ap);
        ::vfancylog(log_service,facility,priority,fmt,aq);
        va_end(aq);
      }

#ifdef __GNUG__
  inline void fancylog (int facility,
                        int priority, const char *fmt, ...)
    __attribute__((format(printf,3,4)));

#endif

    inline void fancylog (int facility,
                          int priority, const char *fmt, ...)
      {
        va_list ap;
        va_start(ap, fmt);
        vfancylog(facility,priority,fmt,ap);
        va_end(ap);
      }
  }
}

#endif // ! FANCYSSL_LOG_H
